.intel_syntax noprefix
.arch pentium
.altmacro
.include "macros.asm"
.include "guitest.inc"

/************************************************************************/

.data

    nrandom_seed:  .long 12345678
    szClass:      .asciz "test_class"
    szName:       .asciz "Test"

.bss

    .lcomm hInst 4
    .lcomm hWnd 4
    .lcomm x 4
    .lcomm y 4

.text

/************************************************************************/

.globl start
start:

    WNDCLASSEX  wcx
    MSG         msg

    invoke GetModuleHandle, 0
    mov hInst, eax
    mov dword ptr wcx.cbSize, 48
    mov dword ptr wcx.style, CS_BYTEALIGNWINDOW
    mov dword ptr wcx.lpfnWndProc, offset(WndProc)
    mov dword ptr wcx.cbClsExtra, 0
    mov dword ptr wcx.cbWndExtra, 0
    push hInst
    pop wcx.hInstance
    invoke GetStockObject, BLACK_BRUSH
    mov wcx.hbrBackground, eax
    mov dword ptr wcx.lpszMenuName,  0
    mov dword ptr wcx.lpszClassName, offset(szClass)
    invoke LoadIcon, 0, IDI_APPLICATION
    mov wcx.hIcon, eax
    invoke LoadCursor, 0, IDC_ARROW
    mov wcx.hCursor, eax
    mov dword ptr wcx.hIconSm, 0

    invoke RegisterClassEx, offset(wcx)

    W = 600
    H = 450
    invoke GetSystemMetrics, SM_CXSCREEN
    shr eax, 1
    sub eax, W / 2
    mov x, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    shr eax, 1
    sub eax, H / 2
    mov y, eax

    xstyle = WS_EX_OVERLAPPEDWINDOW
    style = WS_OVERLAPPEDWINDOW
    invoke CreateWindowEx,xstyle,offset(szClass),offset(szName),style,x,y,W,H,0,0,hInst,0

    mov hWnd, eax
    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd

    invoke SetTimer, hWnd, 0, 30, 0

  msgLoop:

    invoke GetMessage, offset(msg), 0, 0, 0
    test eax, eax
    jz msgQuit
    invoke TranslateMessage, offset(msg)
    invoke DispatchMessage, offset(msg)
    jmp msgLoop

  msgQuit:

    invoke ExitProcess, msg.wParam

/************************************************************************/

.align 16
WndProc:

    PAINTSTRUCT ps
    POINT       pt1
    POINT       pt2
    POINT       pt3
    RECT        rc

    push ebp
    mov ebp, esp

    hwnd = 8; uMsg = 12; wParam = 16; lParam = 20

    cmp dword ptr [ebp+uMsg], WM_PAINT
    jne 1f
    invoke BeginPaint, [ebp+hwnd], offset(ps)
    invoke GetClientRect, [ebp+hwnd], offset(rc)
    invoke nrandom, 0xffffff
    invoke CreateSolidBrush, eax
    push eax
    invoke SelectObject, ps.hdc, eax
    push eax
    invoke nrandom, rc.right
    mov pt1.x, eax
    invoke nrandom, rc.bottom
    mov pt1.y, eax
    invoke nrandom, rc.right
    mov pt2.x, eax
    invoke nrandom, rc.bottom
    mov pt2.y, eax
    invoke nrandom, rc.right
    mov pt3.x, eax
    invoke nrandom, rc.bottom
    mov pt3.y, eax
    invoke Polygon, ps.hdc, offset(pt1), 3
    pop eax
    invoke SelectObject, ps.hdc, eax
    pop eax
    invoke DeleteObject, eax
    invoke EndPaint, [ebp+hwnd], offset(ps)
    jmp 5f
  1:
    cmp dword ptr [ebp+uMsg], WM_TIMER
    jne 2f
    invoke InvalidateRgn, hWnd, 0, 0
    jmp 5f
  2:
    cmp dword ptr [ebp+uMsg], WM_CLOSE
    jne 3f
    invoke DestroyWindow, [ebp+hwnd]
    jmp 5f
  3:
    cmp dword ptr [ebp+uMsg], WM_DESTROY
    jne 4f
    invoke PostQuitMessage, 0
    jmp 5f
  4:
    invoke DefWindowProc,[ebp+hwnd],[ebp+uMsg],[ebp+wParam],[ebp+lParam]
  5:
    leave
    ret 16

/************************************************************************/

.align 16
nrandom:

    push ebp
    mov ebp, esp

    base = 8

    mov eax, nrandom_seed
    test eax, 0x80000000
    jz  1f
    add eax, 0x7fffffff
  1:
    xor edx, edx
    mov ecx, 127773
    div ecx
    mov ecx, eax
    mov eax, 16807
    mul edx
    mov edx, ecx
    mov ecx, eax
    mov eax, 2836
    mul edx
    sub ecx, eax
    xor edx, edx
    mov eax, ecx
    mov nrandom_seed, ecx
    div dword ptr [ebp+base]

    mov eax, edx

    leave
    ret 4

/************************************************************************/
